//+------------------------------------------------------------------+
//|          Free and OpenSource code under MIT License              |
//|              (https://opensource.org/licenses/MIT)               |
//|                      ButtonTrading.mq4                           |
//|                 Copyright 2018 penyuperwira                      |
//|          (https://www.forexfactory.com/penyuperwira)             |
//|                  updated : 25.11.2018                            |
//+------------------------------------------------------------------+
#property copyright "Created by PenyuPerwira https://www.forexfactory.com/showthread.php?t=785645"
#property link      "https://www.forexfactory.com/showthread.php?t=785645"
#property version   "1.00"
#property strict
/*
#include <_Buy_TP1v6@market.mq4>
#include <_Buy_TP6@market.mq4>
#include <_ClearAll_TP1v6@market.mq4>
#include <_Hedge_TP1v6@market.mq4>
#include <_Hedge_TP6@market.mq4>
#include <_Sell_TP1v6@market.mq4>
#include <_Sell_TP6@market.mq4>
*/
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
extern string info="If 'lots' is set to 0, it will try to use the 'ordersize'";
extern double fixed_lot=0.01;
extern double SLpips = 0;
extern double TPpips = 13;
extern string    Use_MM_lots="IF you want to decrease lot by";
extern string    Enable_MM_Percentage_Lots="set Mode_Lots = [1]Fixed [2]%Equity [3]%Balance ";
extern int      Mode_MM_Lots=3;
//extern bool      Mode_MM_Lots_balance=true;
extern double    MM_Risk_Percent_Lots=0.25;
int    MM_Lot_Digits_Decimal=2;
extern bool      ProfitPercen=true;
extern double    ProfitPercent=1.00;
extern bool      StopPercen=false;
extern double    StopPercent=5.00;
extern int Button_Horizontal=120;
extern int Button_Vertical=220;
extern bool CloseProfitOnly=false;
int Slippage=5;
double pip;
int digits;
double Credit;
double Balance;
double GetoLots;
double account_type;
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int OnInit()
  {
   if(SymbolInfoDouble(Symbol(), SYMBOL_TRADE_CONTRACT_SIZE)==1000) account_type=10;
   if(SymbolInfoDouble(Symbol(), SYMBOL_TRADE_CONTRACT_SIZE)==10000) account_type=1;
   if(SymbolInfoDouble(Symbol(), SYMBOL_TRADE_CONTRACT_SIZE)==100000) account_type=0.1;
//---
   int x=Button_Horizontal;
   int y=Button_Vertical;
   int x2=Button_Horizontal;
   int y2=0+Button_Vertical;
   int x3=Button_Horizontal;
   int y3=80+Button_Vertical;
   CreateButton("button1","Buy Net",x,y,80,30,Yellow,Green,White,12);
   CreateButton("button2","Hedge Net",x,y,80,30,Yellow,Blue,White,12);
   CreateButton("button3","Sell Net",x,y,80,30,Yellow,Maroon,White,12);
   CreateButton("button4","Net % TP/SL",x,y,100,30,White,Gray,White,12);
   CreateButton2("button5","Buy",x2,y2+40,80,30,Yellow,Green,White,12);
   CreateButton2("button6","Hedge",x2,y2+40,80,30,Yellow,Blue,White,12);
   CreateButton2("button7","Sell",x2,y2+40,80,30,Yellow,Maroon,White,12);
   CreateButton2("button8","Single TP/SL",x2,y2+40,100,30,White,Gray,White,12);
   CreateButton3("button9","Close Buy",x3,y3,80,30,White,Gray,White,12);
   CreateButton3("button10","Close All",x3,y3,80,30,White,Gray,White,12);
   CreateButton3("button11","Close Sell",x3,y3,80,30,White,Gray,White,12);
   CreateButton3("button12","Delete TP/SL",x3,y3,100,30,White,Gray,White,12);
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//---
   DeleteButtons();
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
//---
  }
//+------------------------------------------------------------------+

void CreateButton(string btnName,string btnText,int &x,int y,int w,int h,color clrText,color clrBg,color clrBorder,int fontSize)
  {
   ObjectCreate(0,btnName,OBJ_BUTTON,0,0,0);
   ObjectSetInteger(0,btnName,OBJPROP_XDISTANCE,x);
   ObjectSetInteger(0,btnName,OBJPROP_YDISTANCE,y);
   ObjectSetInteger(0,btnName,OBJPROP_XSIZE,w);
   ObjectSetInteger(0,btnName,OBJPROP_YSIZE,h);
   ObjectSetString(0,btnName,OBJPROP_TEXT,btnText);
   ObjectSetInteger(0,btnName,OBJPROP_COLOR,clrText);
   ObjectSetInteger(0,btnName,OBJPROP_BGCOLOR,clrBg);
   ObjectSetInteger(0,btnName,OBJPROP_BORDER_COLOR,clrBorder);
   ObjectSetInteger(0,btnName,OBJPROP_BORDER_TYPE,BORDER_FLAT);
   ObjectSetInteger(0,btnName,OBJPROP_HIDDEN,true);
   ObjectSetInteger(0,btnName,OBJPROP_STATE,false);
   ObjectSetInteger(0,btnName,OBJPROP_FONTSIZE,fontSize);
   x=x+w+10;
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void CreateButton2(string btnName,string btnText,int &x2,int y,int w,int h,color clrText,color clrBg,color clrBorder,int fontSize)
  {
   ObjectCreate(0,btnName,OBJ_BUTTON,0,0,0);
   ObjectSetInteger(0,btnName,OBJPROP_XDISTANCE,x2);
   ObjectSetInteger(0,btnName,OBJPROP_YDISTANCE,y);
   ObjectSetInteger(0,btnName,OBJPROP_XSIZE,w);
   ObjectSetInteger(0,btnName,OBJPROP_YSIZE,h);
   ObjectSetString(0,btnName,OBJPROP_TEXT,btnText);
   ObjectSetInteger(0,btnName,OBJPROP_COLOR,clrText);
   ObjectSetInteger(0,btnName,OBJPROP_BGCOLOR,clrBg);
   ObjectSetInteger(0,btnName,OBJPROP_BORDER_COLOR,clrBorder);
   ObjectSetInteger(0,btnName,OBJPROP_BORDER_TYPE,BORDER_FLAT);
   ObjectSetInteger(0,btnName,OBJPROP_HIDDEN,true);
   ObjectSetInteger(0,btnName,OBJPROP_STATE,false);
   ObjectSetInteger(0,btnName,OBJPROP_FONTSIZE,fontSize);
   x2=x2+w+10;
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void CreateButton3(string btnName,string btnText,int &x3,int y,int w,int h,color clrText,color clrBg,color clrBorder,int fontSize)
  {
   ObjectCreate(0,btnName,OBJ_BUTTON,0,0,0);
   ObjectSetInteger(0,btnName,OBJPROP_XDISTANCE,x3);
   ObjectSetInteger(0,btnName,OBJPROP_YDISTANCE,y);
   ObjectSetInteger(0,btnName,OBJPROP_XSIZE,w);
   ObjectSetInteger(0,btnName,OBJPROP_YSIZE,h);
   ObjectSetString(0,btnName,OBJPROP_TEXT,btnText);
   ObjectSetInteger(0,btnName,OBJPROP_COLOR,clrText);
   ObjectSetInteger(0,btnName,OBJPROP_BGCOLOR,clrBg);
   ObjectSetInteger(0,btnName,OBJPROP_BORDER_COLOR,clrBorder);
   ObjectSetInteger(0,btnName,OBJPROP_BORDER_TYPE,BORDER_FLAT);
   ObjectSetInteger(0,btnName,OBJPROP_HIDDEN,true);
   ObjectSetInteger(0,btnName,OBJPROP_STATE,false);
   ObjectSetInteger(0,btnName,OBJPROP_FONTSIZE,fontSize);
   x3=x3+w+10;
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void DeleteButtons()
  {
   for(int i=ObjectsTotal()-1; i>-1; i--)
     {
      if(StringFind(ObjectName(i),"button")>=0) ObjectDelete(ObjectName(i));
     }
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void OnChartEvent(const int id,const long &lparam,const double &dparam,const string &sparam)
  {
   if(sparam=="button1") // Buy Net
     {
      Action_Button1();
      ObjectSetInteger(0,"button1",OBJPROP_STATE,false);
     }
   else if(sparam=="button2") // Hedge Net
     {
      Action_Button2();
      ObjectSetInteger(0,"button2",OBJPROP_STATE,false);
     }
   else if(sparam=="button3") // Sell Net
     {
      Action_Button3();
      ObjectSetInteger(0,"button3",OBJPROP_STATE,false);
     }
   else if(sparam=="button4") // Net % TP
     {
      Action_Button4();
      ObjectSetInteger(0,"button4",OBJPROP_STATE,false);
     }
   if(sparam=="button5") // Buy Net
     {
      Action_Button5();
      ObjectSetInteger(0,"button5",OBJPROP_STATE,false);
     }
   else if(sparam=="button6") // Hedge Net
     {
      Action_Button6();
      ObjectSetInteger(0,"button6",OBJPROP_STATE,false);
     }
   else if(sparam=="button7") // Sell Net
     {
      Action_Button7();
      ObjectSetInteger(0,"button7",OBJPROP_STATE,false);
     }
   else if(sparam=="button8") //Single TP
     {
      Action_Button8();
      ObjectSetInteger(0,"button8",OBJPROP_STATE,false);
     }
   else if(sparam=="button9") // Close Buy
     {
      Action_Button9();
      ObjectSetInteger(0,"button9",OBJPROP_STATE,false);
     }
   else if(sparam=="button10") // Close All
     {
      Action_Button10();
      ObjectSetInteger(0,"button10",OBJPROP_STATE,false);
     }
   else if(sparam=="button11") // Close Sell
     {
      Action_Button11();
      ObjectSetInteger(0,"button11",OBJPROP_STATE,false);
     }
   else if(sparam=="button12") // Delete TP
     {
      Action_Button12();
      ObjectSetInteger(0,"button12",OBJPROP_STATE,false);
     }
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void Action_Button1()
  {
   OrderBuyNet();
   PlaySound("ok.wav");
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void Action_Button2()
  {
   OrderBuyNet();
   OrderSellNet();
   PlaySound("ok.wav");
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void Action_Button3()
  {
   OrderSellNet();
   PlaySound("ok.wav");
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void Action_Button4()
  {
   NetTP();
   PlaySound("ok.wav");
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void Action_Button5()
  {
   OrderBuy();
   PlaySound("ok.wav");
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void Action_Button6()
  {
   OrderBuy();
   OrderSell();
   PlaySound("ok.wav");
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void Action_Button7()
  {
   OrderSell();
   PlaySound("ok.wav");
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void Action_Button8()
  {
   SingleTP();
   PlaySound("ok.wav");
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void Action_Button9()
  {
   CloseBuy();
   PlaySound("ok.wav");
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void Action_Button10()
  {
   CloseAll();
   PlaySound("ok.wav");
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void Action_Button11()
  {
   CloseSell();
   PlaySound("ok.wav");
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void Action_Button12()
  {
   DeleteTP();
   PlaySound("ok.wav");
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void OrderBuyNet()
  {
   double SL,TP;
   int i,Total;
   Total=OrdersTotal();
   int err;
//+------------------------------------------------------------------+
   double AE=AccountEquity();
//      pl_bal=AE;
//    if(T()==0){ pl_factor=AE/pl_bal; }
//+------------------------------------------------------------------+
   double Bprofit=0,BLots=0,BLotsSymbol=0;
   for(int j=0; j<OrdersTotal(); j++)
     {
      int ticket2=OrderSelect(j,SELECT_BY_POS,MODE_TRADES);
      if(ticket2<0)//----added by tradercapaym
        {
         // Print("CL-849 , OrderSelect Error: ", GetLastError());
        }
      else
        {
         // Print("CL-853 , Order Select Successfully, Ticket # is : " + OrderTicket());
        }
      // if(cmd()>1) continue;
      if(OrderType()==0 && OrderSymbol()==Symbol()) Bprofit+=OrderProfit();
      if(OrderType()==0 && OrderSymbol()==Symbol()) BLotsSymbol+=OrderLots();
     }
//double tp_m2=Bprofit;
//+------------------------------------------------------------------+
   getpip();
   Credit=AccountCredit();
   Balance=AccountBalance();
   GetoLots=GetLots();
   double StopPercentage=(Balance+Credit) *(StopPercent/100);
   double StopPipsMath=NormalizeDouble((StopPercentage-(Bprofit))/((BLotsSymbol+GetoLots)/account_type),0);
   double ProfitPercentage=(Balance+Credit) *(ProfitPercent/100);
   double ProfitPipsMath=NormalizeDouble((ProfitPercentage-(Bprofit))/((BLotsSymbol+GetoLots)/account_type),0);
   if(fixed_lot==0) fixed_lot = GlobalVariableGet("ordersize");
   if(fixed_lot==0)
     {
      Alert("!!! "+WindowExpertName()+" "+Symbol()+": 'ordersize' not defined !!!");
     }
   double SLprice=0;
   double TPprice=0;
   double Price=Bid;
   if(!StopPercen   && SLpips       !=0) SLprice=Price-SLpips*pip;
   if(StopPercen    && StopPercent  !=0) SLprice=Price-StopPipsMath*pip;
   if(!ProfitPercen && TPpips       !=0) TPprice=Price+TPpips*pip;
   if(ProfitPercen  && ProfitPercent!=0) TPprice=Price+ProfitPipsMath*pip;
   int ticket=OrderSend(Symbol(),OP_BUY,GetoLots,Price,30,SLprice,TPprice,"",0,0,Green);
//+------------------------------------------------------------------+
//  double SL,TP;
//int i,Total;
// int Dig=MarketInfo(Symbol(),MODE_DIGITS);     
//+------------------------------------------------------------------+
   if(Total>0)
     {
      for(i=Total-1; i>=0; i--)
        {
         if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==true)
           {
            if(OrderSymbol()==Symbol() && OrderType()==OP_BUY)
              {
               if(SLpips>0)SL=SLprice;else SL=0;
               if(TPpips>0)TP=TPprice;else TP=0;
               int ticket3=OrderModify(OrderTicket(),OrderOpenPrice(),SL,TP,OrderExpiration(),CLR_NONE);
              }
           }
        }
     }
   if(ticket<0)
     {
      err=GetLastError();

      Alert(Symbol()+":BUY FAILED : ErrorDescription("+IntegerToString(err)+")");
     }
   else
     {
      Alert(Symbol()+":BUY at "+DoubleToStr(Price,Digits)+" TP="+DoubleToStr(TPprice,Digits)+",SL="+DoubleToStr(SLprice,Digits));
     }
   Alert("--- END "+WindowExpertName()+" "+Symbol());
   RefreshRates();
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void OrderSellNet()
  {
   double SL,TP;
   int i,Total;
   Total=OrdersTotal();
   int err;
//+------------------------------------------------------------------+
   double AE=AccountEquity();
//      pl_bal=AE;
//    if(T()==0){ pl_factor=AE/pl_bal; }
//+------------------------------------------------------------------+
   double Sprofit=0,SLots=0,SLotsSymbol=0;
   for(int j=0; j<OrdersTotal(); j++)
     {
      int ticket2=OrderSelect(j,SELECT_BY_POS,MODE_TRADES);
      if(ticket2<0)//----added by tradercapaym
        {
         // Print("CL-849 , OrderSelect Error: ", GetLastError());
        }
      else
        {
         // Print("CL-853 , Order Select Successfully, Ticket # is : " + OrderTicket());
        }
      // if(cmd()>1) continue;
      if(OrderType()==1 && OrderSymbol()==Symbol())Sprofit+=OrderProfit();
      if(OrderType()==1 && OrderSymbol()==Symbol())SLotsSymbol+=OrderLots();
     }
//double tp_m2=profit;
//+------------------------------------------------------------------+
   getpip();
   Credit=AccountCredit();
   Balance=AccountBalance();
   GetoLots=GetLots();
   double StopPercentage=(Balance+Credit) *(StopPercent/100);
   double StopPipsMath=NormalizeDouble((StopPercentage-(Sprofit))/((SLotsSymbol+GetoLots)/account_type),0);
   double ProfitPercentage=(Balance+Credit) *(ProfitPercent/100);
   double ProfitPipsMath=NormalizeDouble((ProfitPercentage-(Sprofit))/((SLotsSymbol+GetoLots)/account_type),0);
   if(fixed_lot==0) fixed_lot = GlobalVariableGet("ordersize");
   if(fixed_lot==0)
     {
      Alert("!!! "+WindowExpertName()+" "+Symbol()+": 'ordersize' not defined !!!");
     }
   double SLprice=0;
   double TPprice=0;
   double Price=Ask;
   if(!StopPercen   && SLpips       !=0) SLprice = Price+SLpips*pip;
   if(StopPercen    && StopPercent  !=0) SLprice = Price+StopPipsMath*pip;
   if(!ProfitPercen && TPpips       !=0) TPprice = Price-TPpips*pip;
   if(ProfitPercen  && ProfitPercent!=0) TPprice = Price-ProfitPipsMath*pip;
   int ticket=OrderSend(Symbol(),OP_SELL,GetoLots,Price,30,SLprice,TPprice,"",0,0,Green);
//+------------------------------------------------------------------+
//  double SL,TP;
//int i,Total;
// int Dig=MarketInfo(Symbol(),MODE_DIGITS);     
//+------------------------------------------------------------------+
   if(Total>0)
     {
      for(i=Total-1; i>=0; i--)
        {
         if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==true)
           {
            if(OrderSymbol()==Symbol() && OrderType()==OP_SELL)
              {
               if(SLpips>0)SL=SLprice;else SL=0;
               if(TPpips>0)TP=TPprice;else TP=0;
               int ticket3=OrderModify(OrderTicket(),OrderOpenPrice(),SL,TP,OrderExpiration(),CLR_NONE);
              }
           }
        }
     }
//+------------------------------------------------------------------+
   if(ticket<0)
     {
      err=GetLastError();
      Alert(Symbol()+":SELL FAILED : ErrorDescription("+IntegerToString(err)+"");
     }
   else
     {
      Alert(Symbol()+":SELL at "+DoubleToStr(Price,Digits)+" TP="+DoubleToStr(TPprice,Digits)+",SL="+DoubleToStr(SLprice,Digits));
     }

   Alert("--- END "+WindowExpertName()+" "+Symbol());
   RefreshRates();
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void OrderBuy()
  {
   double SL,TP;
   int err;
   getpip();
   Credit=AccountCredit();
   double StopPercentage=(Balance+Credit) *(StopPercent/100);
   double StopPipsMath=NormalizeDouble((StopPercentage)/(GetLots()/account_type),0);
   double ProfitPercentage=(AccountBalance()+Credit) *(ProfitPercent/100);
   double ProfitPipsMath=NormalizeDouble((ProfitPercentage)/(GetLots()/account_type),0);
   if(fixed_lot==0) fixed_lot = GlobalVariableGet("ordersize");
   if(fixed_lot==0)
     {
      Alert("!!! "+WindowExpertName()+" "+Symbol()+": 'ordersize' not defined !!!");
     }
   double SLprice=0;
   double TPprice=0;
   double Price=Bid;
   if(!StopPercen   && SLpips       !=0) SLprice=Price-SLpips*pip;
   if(StopPercen    && StopPercent  !=0) SLprice=Price-StopPipsMath*pip;
   if(!ProfitPercen && TPpips       !=0) TPprice=Price+TPpips*pip;
   if(ProfitPercen  && ProfitPercent!=0) TPprice=Price+ProfitPipsMath*pip;
   if(StopPercent>0) SL=SLprice;  else SL=0; //buy trade
   if(ProfitPercent>0)TP=TPprice;  else TP=0;
   int ticket=OrderSend(Symbol(),OP_BUY,GetLots(),Price,30,SL,TP,"",0,0,Green);
   if(ticket<0)
     {
      err=GetLastError();
      Alert(Symbol()+":BUY FAILED : ErrorDescription("+IntegerToString(err)+"");
     }
   else
     {
      Alert(Symbol()+":BUY at "+DoubleToStr(Price,Digits)+" TP="+DoubleToStr(TP,Digits)+",SL="+DoubleToStr(SL,Digits));
     }
   Alert("--- END "+WindowExpertName()+" "+Symbol());
   RefreshRates();
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void OrderSell()
  {
   double SL2,TP2;
   int err;
   getpip();
   Credit=AccountCredit();
   double StopPercentage2=(Balance+Credit) *(StopPercent/100);
   double StopPipsMath2=NormalizeDouble((StopPercentage2)/(GetLots()/account_type),0);
   double ProfitPercentage2=(AccountBalance()+Credit) *(ProfitPercent/100);
   double ProfitPipsMath2=NormalizeDouble((ProfitPercentage2)/(GetLots()/account_type),0);
   if(fixed_lot==0) fixed_lot = GlobalVariableGet("ordersize");
   if(fixed_lot==0)
     {
      Alert("!!! "+WindowExpertName()+" "+Symbol()+": 'ordersize' not defined !!!");
     }
   double SLprice2=0;
   double TPprice2=0;
   double Price2=Ask;
   if(!StopPercen   && SLpips       !=0) SLprice2 = Price2+SLpips*pip;
   if(StopPercen    && StopPercent  !=0) SLprice2 = Price2+StopPipsMath2*pip;
   if(!ProfitPercen && TPpips       !=0) TPprice2 = Price2-TPpips*pip;
   if(ProfitPercen  && ProfitPercent!=0) TPprice2 = Price2-ProfitPipsMath2*pip;
   if(StopPercent>0) SL2=SLprice2; else SL2=0;//sell trade
   if(ProfitPercent>0)TP2=TPprice2; else TP2=0;
   int ticket=OrderSend(Symbol(),OP_SELL,GetLots(),Price2,30,SL2,TP2,"",0,0,Green);
   if(ticket<0)
     {
      err=GetLastError();
      Alert(Symbol()+":SELL FAILED : ErrorDescription("+IntegerToString(err)+"");
     }
   else
     {
      Alert(Symbol()+":SELL at "+DoubleToStr(Price2,Digits)+" TP="+DoubleToStr(TP2,Digits)+",SL="+DoubleToStr(SL2,Digits));
     }
   Alert("--- END "+WindowExpertName()+" "+Symbol());
   RefreshRates();
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void DeleteTP()
  {
   int i,Total;
   Total=OrdersTotal();
//+------------------------------------------------------------------+
   if(Total>0)
     {
      for(i=Total-1; i>=0; i--)
        {
         if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==true)
           {
            if(OrderSymbol()==Symbol() && OrderType()==OP_BUY)
              {
               int ticket4=OrderModify(OrderTicket(),OrderOpenPrice(),0,0,OrderExpiration(),CLR_NONE);
              }
            if(OrderSymbol()==Symbol() && OrderType()==OP_SELL)
              {
               int ticket5=OrderModify(OrderTicket(),OrderOpenPrice(),0,0,OrderExpiration(),CLR_NONE);
              }
           }
        }
     }
   return;
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void CloseBuy()
  {
   bool closed=false;
   for(int i=OrdersTotal(); i>=0; i--)
     {
      int ticket=OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
      if(ticket<0)//----added by tradercapaym
        {
         // Print("CL-849 , OrderSelect Error: ", GetLastError());
        }
      else
        {
         // Print("CL-853 , Order Select Successfully, Ticket # is : " + OrderTicket());
        }
      while(IsTradeContextBusy()) Sleep(100);
      RefreshRates();
      if(OrderType()==OP_BUY && Symbol()==OrderSymbol() && !CloseProfitOnly)
        {
         closed=OrderClose(OrderTicket(),OrderLots(),Bid,Slippage,White);
        }
      else if(OrderType()==OP_BUY && Symbol()==OrderSymbol() && CloseProfitOnly && OrderProfit()>0)
        {
         closed=OrderClose(OrderTicket(),OrderLots(),Ask,Slippage,White);
        }
     }
   return;
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void CloseAll()
  {
   bool closed=false;
   for(int i=OrdersTotal(); i>=0; i--)
     {
      int ticket=OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
      if(ticket<0)//----added by tradercapaym
        {
         // Print("CL-849 , OrderSelect Error: ", GetLastError());
        }
      else
        {
         // Print("CL-853 , Order Select Successfully, Ticket # is : " + OrderTicket());
        }
      while(IsTradeContextBusy()) Sleep(100);
      RefreshRates();

      if(OrderType()==OP_BUY && Symbol()==OrderSymbol() && !CloseProfitOnly)
        {
         closed=OrderClose(OrderTicket(),OrderLots(),Bid,Slippage,White);
        }
      else if(OrderType()==OP_BUY && Symbol()==OrderSymbol() && CloseProfitOnly && OrderProfit()>0)
        {
         closed=OrderClose(OrderTicket(),OrderLots(),Ask,Slippage,White);
        }
      if(OrderType()==OP_SELL && Symbol()==OrderSymbol() && !CloseProfitOnly)
        {
         closed=OrderClose(OrderTicket(),OrderLots(),Ask,Slippage,White);
        }
      else if(OrderType()==OP_SELL && Symbol()==OrderSymbol() && CloseProfitOnly && OrderProfit()>0)
        {
         closed=OrderClose(OrderTicket(),OrderLots(),Ask,Slippage,White);
        }
     }
   return;
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void CloseSell()
  {
   bool closed=false;
   for(int i=OrdersTotal(); i>=0; i--)
     {
      int ticket=OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
      if(ticket<0)//----added by tradercapaym
        {
         // Print("CL-849 , OrderSelect Error: ", GetLastError());
        }
      else
        {
         // Print("CL-853 , Order Select Successfully, Ticket # is : " + OrderTicket());
        }
      while(IsTradeContextBusy()) Sleep(100);
      RefreshRates();
      if(OrderType()==OP_SELL && Symbol()==OrderSymbol() && !CloseProfitOnly)
        {
         closed=OrderClose(OrderTicket(),OrderLots(),Ask,Slippage,White);
        }
      else if(OrderType()==OP_SELL && Symbol()==OrderSymbol() && CloseProfitOnly && OrderProfit()>0)
        {
         closed=OrderClose(OrderTicket(),OrderLots(),Ask,Slippage,White);
        }
     }
   return;
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void NetTP()
  {
   double SL,TP,SL2,TP2;
   int i,Total;
   Total=OrdersTotal();
//+------------------------------------------------------------------+
   double AE=AccountEquity();
//      pl_bal=AE;
//    if(T()==0){ pl_factor=AE/pl_bal; }
//+------------------------------------------------------------------+
   double Bprofit=0,Sprofit=0,BLotsSymbol=0,SLotsSymbol=0;
   for(int j=0; j<OrdersTotal(); j++)
     {
      int ticket2=OrderSelect(j,SELECT_BY_POS,MODE_TRADES);
      if(ticket2<0)//----added by tradercapaym
        {
         // Print("CL-849 , OrderSelect Error: ", GetLastError());
        }
      else
        {
         // Print("CL-853 , Order Select Successfully, Ticket # is : " + OrderTicket());
        }
      // if(cmd()>1) continue;
      if(OrderSymbol()==Symbol() && OrderType()==OP_SELL)Sprofit+=OrderProfit();
      if(OrderSymbol()==Symbol() && OrderType()==OP_SELL)SLotsSymbol+=OrderLots();
      if(OrderSymbol()==Symbol() && OrderType()==OP_BUY) Bprofit+=OrderProfit();
      if(OrderSymbol()==Symbol() && OrderType()==OP_BUY) BLotsSymbol+=OrderLots();
     }
//double tp_m2=Bprofit;
   getpip();
   Credit=AccountCredit();
   Balance=AccountBalance();
//GetoLots=GetLots();
   if(fixed_lot==0) fixed_lot=GlobalVariableGet("ordersize");
   if(fixed_lot==0)
     {
      Alert("!!! "+WindowExpertName()+" "+Symbol()+": 'ordersize' not defined !!!");
     }
//+------------------------------------------------------------------+
   if(Total>0)
     {
      for(i=Total-1; i>=0; i--)
        {
         if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==true)
           {
            if(OrderSymbol()==Symbol() && OrderType()==OP_BUY && BLotsSymbol!=0)
              {
               double StopPercentage=(Balance+Credit) *(StopPercent/100);
               double StopPipsMath=NormalizeDouble((StopPercentage-(Bprofit))/((BLotsSymbol)/account_type),0);
               double ProfitPercentage=(Balance+Credit) *(ProfitPercent/100);
               double ProfitPipsMath=NormalizeDouble((ProfitPercentage-(Bprofit))/((BLotsSymbol)/account_type),0);
               double SLprice=0;
               double TPprice=0;
               double Price=Bid;
               if(!StopPercen   && SLpips       !=0) SLprice=Price-SLpips*pip;
               if(StopPercen    && StopPercent  !=0) SLprice=Price-StopPipsMath*pip;
               if(!ProfitPercen && TPpips       !=0) TPprice=Price+TPpips*pip;
               if(ProfitPercen  && ProfitPercent!=0) TPprice=Price+ProfitPipsMath*pip;
               if(StopPercent>0) SL=SLprice;  else SL=0; //buy trade
               if(ProfitPercent>0)TP=TPprice;  else TP=0;
               int ticket4=OrderModify(OrderTicket(),OrderOpenPrice(),SL,TP,OrderExpiration(),CLR_NONE);
              }
            if(OrderSymbol()==Symbol() && OrderType()==OP_SELL && SLotsSymbol!=0)
              {
               double StopPercentage2=(Balance+Credit) *(StopPercent/100);
               double StopPipsMath2=NormalizeDouble((StopPercentage2-(Sprofit))/((SLotsSymbol)/account_type),0);
               double ProfitPercentage2=(Balance+Credit) *(ProfitPercent/100);
               double ProfitPipsMath2=NormalizeDouble((ProfitPercentage2-(Sprofit))/((SLotsSymbol)/account_type),0);
               double SLprice2=0;
               double TPprice2=0;
               double Price2=Ask;
               if(!StopPercen   && SLpips       !=0) SLprice2 = Price2+SLpips*pip;
               if(StopPercen    && StopPercent  !=0) SLprice2 = Price2+StopPipsMath2*pip;
               if(!ProfitPercen && TPpips       !=0) TPprice2 = Price2-TPpips*pip;
               if(ProfitPercen  && ProfitPercent!=0) TPprice2 = Price2-ProfitPipsMath2*pip;
               if(StopPercent>0) SL2=SLprice2; else SL2=0;//sell trade
               if(ProfitPercent>0)TP2=TPprice2; else TP2=0;
               int ticket5=OrderModify(OrderTicket(),OrderOpenPrice(),SL2,TP2,OrderExpiration(),CLR_NONE);
              }
           }
        }
     }
   RefreshRates();
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+  
void SingleTP()
  {
   double SL,TP,SL2,TP2;
   int i,Total;
   Total=OrdersTotal();
//+------------------------------------------------------------------+
   double AE=AccountEquity();
//      pl_bal=AE;
//    if(T()==0){ pl_factor=AE/pl_bal; }
//+------------------------------------------------------------------+
   double Bprofit=0,Sprofit=0,BLotsSymbol=0,SLotsSymbol=0;
   for(int j=0; j<OrdersTotal(); j++)
     {
      int ticket2=OrderSelect(j,SELECT_BY_POS,MODE_TRADES);
      if(ticket2<0)//----added by tradercapaym
        {
         // Print("CL-849 , OrderSelect Error: ", GetLastError());
        }
      else
        {
         // Print("CL-853 , Order Select Successfully, Ticket # is : " + OrderTicket());
        }
      // if(cmd()>1) continue;
      // if(OrderSymbol()==Symbol() && OrderType()==OP_SELL)Sprofit+=OrderProfit();
      if(OrderSymbol()==Symbol() && OrderType()==OP_SELL)SLotsSymbol+=OrderLots();
      // if(OrderSymbol()==Symbol() && OrderType()==OP_BUY) Bprofit+=OrderProfit();
      if(OrderSymbol()==Symbol() && OrderType()==OP_BUY) BLotsSymbol+=OrderLots();
     }
//double tp_m2=Bprofit;
   getpip();
   Credit=AccountCredit();
   Balance=AccountBalance();
//GetoLots=GetLots();
   if(fixed_lot==0) fixed_lot=GlobalVariableGet("ordersize");
   if(fixed_lot==0)
     {
      Alert("!!! "+WindowExpertName()+" "+Symbol()+": 'ordersize' not defined !!!");
     }
//+------------------------------------------------------------------+
   if(Total>0)
     {
      for(i=Total-1; i>=0; i--)
        {
         if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==true)
           {
            if(OrderSymbol()==Symbol() && OrderType()==OP_BUY && BLotsSymbol!=0)
              {
               double StopPercentage=(Balance+Credit) *(StopPercent/100);
               double StopPipsMath=NormalizeDouble((StopPercentage)/(GetLots()/account_type),0);
               double ProfitPercentage=(Balance+Credit) *(ProfitPercent/100);
               double ProfitPipsMath=NormalizeDouble((ProfitPercentage)/(GetLots()/account_type),0);
               double SLprice=0;
               double TPprice=0;
               double Price=OrderOpenPrice();
               if(!StopPercen   && SLpips       !=0) SLprice=Price-SLpips*pip;
               if(StopPercen    && StopPercent  !=0) SLprice=Price-StopPipsMath*pip;
               if(!ProfitPercen && TPpips       !=0) TPprice=Price+TPpips*pip;
               if(ProfitPercen  && ProfitPercent!=0) TPprice=Price+ProfitPipsMath*pip;
               if(StopPercent>0) SL=SLprice;  else SL=0; //buy trade
               if(ProfitPercent>0)TP=TPprice;  else TP=0;
               int ticket4=OrderModify(OrderTicket(),OrderOpenPrice(),SL,TP,OrderExpiration(),CLR_NONE);
              }
            if(OrderSymbol()==Symbol() && OrderType()==OP_SELL && SLotsSymbol!=0)
              {
               double StopPercentage2=(Balance+Credit) *(StopPercent/100);
               double StopPipsMath2=NormalizeDouble((StopPercentage2)/(GetLots()/account_type),0);
               double ProfitPercentage2=(Balance+Credit) *(ProfitPercent/100);
               double ProfitPipsMath2=NormalizeDouble((ProfitPercentage2)/(GetLots()/account_type),0);
               double SLprice2=0;
               double TPprice2=0;
               double Price2=OrderOpenPrice();
               if(!StopPercen   && SLpips       !=0) SLprice2 = Price2+SLpips*pip;
               if(StopPercen    && StopPercent  !=0) SLprice2 = Price2+StopPipsMath2*pip;
               if(!ProfitPercen && TPpips       !=0) TPprice2 = Price2-TPpips*pip;
               if(ProfitPercen  && ProfitPercent!=0) TPprice2 = Price2-ProfitPipsMath2*pip;
               if(StopPercent>0) SL2=SLprice2; else SL2=0;//sell trade
               if(ProfitPercent>0)TP2=TPprice2; else TP2=0;
               int ticket5=OrderModify(OrderTicket(),OrderOpenPrice(),SL2,TP2,OrderExpiration(),CLR_NONE);
              }
           }
        }
     }
   RefreshRates();
  }
//--------------------------------------------------------------------------------------
// getpip
//--------------------------------------------------------------------------------------
void getpip()
  {
   if(Digits==2 || Digits==4) pip=Point;
   else if(Digits==3 || Digits==5) pip = 10*Point;
   else if(Digits==6) pip = 100*Point;
   if(Digits==3 || Digits==2) digits=2;
   else digits=4;
  }
//+------------------------------------------------------------------+
//|                       Money Management                           |
//+------------------------------------------------------------------+
double GetLots()
  {
   double MM_lots=0;
   Credit=AccountCredit();
   Balance=AccountBalance();
   double MM_minlot = MarketInfo(Symbol(), MODE_MINLOT);
   double MM_maxlot = MarketInfo(Symbol(), MODE_MAXLOT);
   double MM_leverage= AccountLeverage();
   double MM_lotsize = MarketInfo(Symbol(),MODE_LOTSIZE);
   double MM_stoplevel=MarketInfo(Symbol(),MODE_STOPLEVEL);
   double xecn=1; if(Digits==5 || Digits==3){xecn=10;}
//+------------------------------------------------------------------+
   if(Mode_MM_Lots==1)
     {
      MM_lots=NormalizeDouble(fixed_lot,Digits);
     }
//+------------------------------------------------------------------+
   else if(Mode_MM_Lots==2)
     {

      //MM_lots = NormalizeDouble(AccountFreeMargin() * MM_Risk_Percent_Lots/100 / 1000.0, MM_Lot_Digits_Decimal);
      //MM_lots = MathFloor((AccountFreeMargin() *AccountLeverage()*MM_Risk_Percent_Lots*Point*100)/(Ask*MarketInfo(Symbol(),MODE_LotSIZE)*MarketInfo(Symbol(),MODE_MINLOT )))*MarketInfo(Symbol(),MODE_MINLOT );
      MM_lots=NormalizeDouble((AccountFreeMargin()*MM_leverage*MM_Risk_Percent_Lots*Point*xecn*100/(Ask*MM_lotsize*MM_minlot)*MM_minlot),MM_Lot_Digits_Decimal);
      if(MM_lots < MM_minlot) MM_lots = MM_minlot;
      if(MM_lots > MM_maxlot) MM_lots = MM_maxlot;
      if(AccountFreeMargin()<Ask*MM_lots*MM_lotsize/MM_leverage)
        {
         Print("We have no money. Lots = ",MM_lots," , Free Margin = ",AccountFreeMargin());
         Comment("We have no money. Lots = ",MM_lots," , Free Margin = ",AccountFreeMargin());
        }
     }
//+------------------------------------------------------------------+
   else if(Mode_MM_Lots==3)
     {
      //MM_lots = NormalizeDouble((Balance+Credit) * MM_Risk_Percent_Lots/100 / 1000.0, MM_Lot_Digits_Decimal);
      //MM_lots = MathFloor((AccountFreeMargin() *AccountLeverage()*MM_Risk_Percent_Lots*Point*100)/(Ask*MarketInfo(Symbol(),MODE_LotSIZE)*MarketInfo(Symbol(),MODE_MINLOT )))*MarketInfo(Symbol(),MODE_MINLOT );
      //MM_lots=NormalizeDouble((AccountFreeMargin()*MM_leverage*MM_Risk_Percent_Lots*Point*xecn*100/(Ask*MM_lotsize*MM_minlot)*MM_minlot),MM_Lot_Digits_Decimal);
      MM_lots=NormalizeDouble(((Balance+Credit)*MM_leverage*MM_Risk_Percent_Lots*Point*xecn*100/(Ask*MM_lotsize*MM_minlot)*MM_minlot),MM_Lot_Digits_Decimal);
      if(MM_lots < MM_minlot) MM_lots = MM_minlot;
      if(MM_lots > MM_maxlot) MM_lots = MM_maxlot;
      if(AccountFreeMargin()<Ask*MM_lots*MM_lotsize/MM_leverage)
        {
         Print("We have no money. Lots = ",MM_lots," , Free Margin = ",AccountFreeMargin());
         Comment("We have no money. Lots = ",MM_lots," , Free Margin = ",AccountFreeMargin());
        }
     }
   return(MM_lots);
  }
//+------------------------------------------------------------------+
